// Напряжение питания: 3.3В и 5В
// ► Чип памяти: AT24C32 (32 Кб)
// ► Точность: ± 0.432 сек в день
// ► Частота кварца:32.768 кГц
// Группы контактов - J1
// 32K:   выход генератора, частота 32 кГц
// SQW: Выход прямоугольного(Square-Wave) сигнала.
// SCL:   Serial CLock - шина тактовых импульсов интерфейса I2C
// SDA:  Serial Data - шина данных интерфейса I2C;
// VCC:  «+» питание модуля
// GND: «-» питание модуля
// Группы контактов - J2
// SCL:   линия тактирования (Serial CLock)
// SDA:  линия данных (Serial Data)
// VCC:  «+» питание модуля
// GND: «-» питание модуля
#include "ds3231.h"
//#include "i2c.h"

// https://github.com/AndreyBogatyrev/WeatherStation/blob/main/Src/ds3231.c
// инициализация часов реального времени
void ds3231init() {
  uint8_t init[3] = {DS3231_CONTROL_ADDR, 0x0, 0x0};
  zi2c_write(DS3231_I2C_ADDR_WRITE, init, 3);
}

// получение даты и времени из RTC
void ds3231get(struct ds3231_calendar* cal) {
  uint8_t date[7] = {0};
  uint8_t addr = 0;
  zi2c_write(DS3231_I2C_ADDR_WRITE, &addr, 1);
  zi2c_read(DS3231_I2C_ADDR_READ, date, 7);        
  cal->second=date[0];
  cal->minute=date[1];
  cal->hour=date[2];
  cal->dayWeek=date[3];
  cal->dayMonth=date[4];
  cal->month=date[5];
  cal->year=date[6];
}

// записать дату и время в RTC
void ds3231set(struct ds3231_calendar* cal) {
  uint8_t new_data[8] = {
    DS3231_SEC_ADDR, 
    cal->second,
    cal->minute,
    cal->hour,
    cal->dayWeek,
    cal->dayMonth,
    cal->month,
    cal->year
  };
  zi2c_write(DS3231_I2C_ADDR_WRITE, new_data, 8);
}